﻿using System;
using System.Collections.Generic;
using System.Configuration;
using System.IO;
using System.Linq;
using System.Text;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

public partial class MultiFilesUploadWithProgress : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        btnUpload.Attributes.Add("style", "display:none");
    }

    protected void btnUpload_Click(object sender, EventArgs e)
    {
        try
        {
            HttpFileCollection UploadedFiles = this.Request.Files;
            CreateProgress(UploadedFiles);
            for (int i = 0; i < UploadedFiles.Count; i++)
            {
                string strFileName = System.IO.Path.GetFileName(UploadedFiles[i].FileName);
                string strFileSize = UploadedFiles[i].ContentLength.ToString();
                string strFileContent = UploadedFiles[i].ContentType;
                DownloadTheFileToServer(UploadedFiles[i], i);
            }
            RemoveProgress();
        }
        catch (Exception ex)
        {
            Response.Write(ex.Message);
        }
    }

    public void CreateProgress(HttpFileCollection fileCollection)
    {
        StringBuilder sbProgress = new StringBuilder();
        sbProgress.Append("<html><head></head>  <body>");       //构造输出内容
        sbProgress.Append("<script src='FilesUpload.js' type='text/javascript'></script><table id='mainTable' border='0'>");
        for (int i = 0; i < fileCollection.Count; i++)
        {
            string strProgressBarId = "progressBar" + i;
            string strPercentageId = "percentage" + i;
            string fileName = fileCollection[i].FileName;
            sbProgress.Append("<tr><td>");
            sbProgress.Append("<p style = 'float:left; margin-left:0px; margin-right:10px;'>" + fileName + "</p>");
            sbProgress.Append("<div style='background-color:White; width: 100px;height:12px; border-color:Black;border-width:thin;border-style:solid;float:left; margin-left:0px; margin-right:10px'>");
            sbProgress.Append("<div style='background-color:Green;height:12px;' id='" + strProgressBarId + "' ></div></div>");
            sbProgress.Append("<p float:left; margin-left:0px; margin-right:10px;'><div id='" + strPercentageId + "'></div></p>");
            sbProgress.Append("</td></tr>");
        }
        sbProgress.Append("</table>");
        for (int i = 0; i < fileCollection.Count; i++)
        {
            sbProgress.Append("<script type='text/javascript'> SetProgressBarProgressAmount(" + i + ",0 );</script>");
        }
        sbProgress.Append("</body></html>");

        HttpContext.Current.Response.Write(sbProgress.ToString());
        HttpContext.Current.Response.Flush();       //强制输出内容
    }

    public void DownloadTheFileToServer(HttpPostedFile file, int id)
    {
        Stream stream = null;
        FileStream fs = null;

        #region File Download Code goes here
        try
        {
            string strFileName = System.IO.Path.GetFileName(file.FileName);
            int contentLength = file.ContentLength;
            stream = file.InputStream;
            long totalUploadSize = stream.Length;
            int bufferSize = 0;
            //less than 1kB
            if (totalUploadSize <= 1024)
            {
                bufferSize = 1024;
            }
            //less than 4kB but more than 1kB
            else if (bufferSize <= 4096)
            {
                bufferSize = 4096;
            }
            //less than 8Kb
            else if (bufferSize <= 8192)
            {
                bufferSize = 8192;
            }
            else
            {
                bufferSize = 16384;
            }

            byte[] b = new byte[bufferSize];
            int tripDownloadSize = 0;
            long totalDownloadedSize = 0;
            float Percentage = 0;
            string fileStoreLocation = ConfigurationManager.AppSettings["FileStoreLocation"];
            fs = new FileStream(fileStoreLocation + strFileName, FileMode.Append);

            //Uplaods 8Kb at a time
            while ((tripDownloadSize = stream.Read(b, 0, bufferSize)) > 0)
            {
                fs.Write(b, 0, tripDownloadSize);
                totalDownloadedSize += tripDownloadSize;
                Percentage = (int)(totalDownloadedSize * 100) / totalUploadSize;
                setProgressBar(id, Percentage.ToString());      //更新进度
                System.Threading.Thread.Sleep(100);
            }
        }
        catch (Exception objException)
        {
            throw objException;
        }
        finally
        {
            if (stream != null)
            {
                stream.Close();
                stream.Dispose();
            }
            if (fs != null)
            {
                fs.Close();
                fs.Dispose();
            }
        }
        #endregion
    }

    public static void setProgressBar(int id, string progressAmount)
    {
        StringBuilder sb = new StringBuilder();
        sb.Append("<body><script type='text/javascript'>SetProgressBarProgressAmount(" + id + ",'" + progressAmount + "'); </script></body>");

        HttpContext.Current.Response.Write(sb.ToString());
        HttpContext.Current.Response.Flush();
    }

    public static void RemoveProgress()
    {
        StringBuilder sbc = new StringBuilder();

        sbc.Append("<body><script language='javascript'>");
        sbc.Append("var up_div=document.getElementById('mainTable');");
        sbc.Append("up_div.style.display='none';");
        sbc.Append("</script></body>");

        HttpContext.Current.Response.Write(sbc);
    }
}